const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class KooperatifDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const kooperatif = await db.kooperatif.create(
      {
        id: data.id || undefined,

        name: data.name || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    return kooperatif;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const kooperatifData = data.map((item, index) => ({
      id: item.id || undefined,

      name: item.name || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const kooperatif = await db.kooperatif.bulkCreate(kooperatifData, {
      transaction,
    });

    // For each item created, replace relation files

    return kooperatif;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const kooperatif = await db.kooperatif.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.name !== undefined) updatePayload.name = data.name;

    updatePayload.updatedById = currentUser.id;

    await kooperatif.update(updatePayload, { transaction });

    return kooperatif;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const kooperatif = await db.kooperatif.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of kooperatif) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of kooperatif) {
        await record.destroy({ transaction });
      }
    });

    return kooperatif;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const kooperatif = await db.kooperatif.findByPk(id, options);

    await kooperatif.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await kooperatif.destroy({
      transaction,
    });

    return kooperatif;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const kooperatif = await db.kooperatif.findOne({ where }, { transaction });

    if (!kooperatif) {
      return kooperatif;
    }

    const output = kooperatif.get({ plain: true });

    output.users_kooperatif = await kooperatif.getUsers_kooperatif({
      transaction,
    });

    output.accounts_kooperatif = await kooperatif.getAccounts_kooperatif({
      transaction,
    });

    output.announcements_kooperatif =
      await kooperatif.getAnnouncements_kooperatif({
        transaction,
      });

    output.barter_offers_kooperatif =
      await kooperatif.getBarter_offers_kooperatif({
        transaction,
      });

    output.delayed_payments_kooperatif =
      await kooperatif.getDelayed_payments_kooperatif({
        transaction,
      });

    output.islamic_finance_library_kooperatif =
      await kooperatif.getIslamic_finance_library_kooperatif({
        transaction,
      });

    output.loan_applications_kooperatif =
      await kooperatif.getLoan_applications_kooperatif({
        transaction,
      });

    output.partners_kooperatif = await kooperatif.getPartners_kooperatif({
      transaction,
    });

    output.projects_kooperatif = await kooperatif.getProjects_kooperatif({
      transaction,
    });

    output.transactions_kooperatif =
      await kooperatif.getTransactions_kooperatif({
        transaction,
      });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userKooperatif = (user && user.kooperatif?.id) || null;

    if (userKooperatif) {
      if (options?.currentUser?.kooperatifId) {
        where.kooperatifId = options.currentUser.kooperatifId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.name) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('kooperatif', 'name', filter.name),
        };
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.kooperatifId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.kooperatif.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('kooperatif', 'name', query),
        ],
      };
    }

    const records = await db.kooperatif.findAll({
      attributes: ['id', 'name'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['name', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.name,
    }));
  }
};
